define(function (require, exports, module) {

    var $ = require('jquery');
    var CascadeView = require('mod/cascadeView');

    function publicSetCascadeView(fieldName, opts) {
        this.cascadeView = new CascadeView({
            $elements: $('#' + fieldName + '-view').find('select'),
            url: '../api/cascade.json',
            onChanged: this.onChanged,
            values: opts.values,
            keepFirstOption: this.keepFirstOption,
            resolveAjax: function (res) {
                if (res.code == 200) {
                    return res.data;
                }
            }
        });
    }

    var LOCATION_VIEWS = {
        licenseLocation: {
            $input: $('input[name="licenseLocation"]'),
            keepFirstOption: true,
            setCascadeView: publicSetCascadeView,
            onChanged: function(e, value){
                LOCATION_VIEWS.licenseLocation.$input.val(value);
            }
        },
        companyLocation: {
            $input: $('input[name="companyLocation"]'),
            keepFirstOption: false,
            setCascadeView: publicSetCascadeView,
            onChanged: function(e, value){
                LOCATION_VIEWS.companyLocation.$input.val(value);
            }
        }
    };

    LOCATION_VIEWS.licenseLocation.setCascadeView('licenseLocation', {
        values: LOCATION_VIEWS.licenseLocation.$input.val()
    });

    LOCATION_VIEWS.companyLocation.setCascadeView('companyLocation', {
        values: LOCATION_VIEWS.companyLocation.$input.val()
    });
});
